# from tkinter import messagebox
from tkinter import filedialog
from tkinter import *
from math import *
from tkinter import messagebox
import subprocess
import json
import subprocess
import platform
import os
import sys

class bcolors:
    OK = '\033[92m' #GREEN
    WARNING = '\033[93m' #YELLOW
    FAIL = '\033[91m' #RED
    RESET = '\033[0m' #RESET COLOR

# ----------- check_run compare a partir de argv si on doit checker la machine
#
#             len(argv) = 1 ==> on doit checker la machine dans tous les cas
#             len(argv) = 2 ==> on doit checker la machine si machine est dans argv ou si argv[1] = "all"
#             len(argv) = 2 si le nom dans argv n'est pas machine on ne chck pas la machine
#
def check_run(machine,argument):

    if len(argument) == 2 or (len(argument)==3 and argument[1]) == "all":
        return(True)
    elif len(argument) == 3:
        if machine == argument[2]:
            return(True)
        else:
            return(False)
    else:
        print("")
        print(bcolors.FAIL + "Erreur --------> Le nombre d'arguments doit etre 1 mini ou 2 maxi")
        print("")
        return(False)

# ---------------------------------- is_machine_live -------------
#   verifie si la machine est active sur le reseau
#   return 1 si la machine est live
#          0 si la machine est bien connue mais ne repond pas
#          -1 si il et impossible de resoudre le nom de la machine
#          -2 dans les autres cas

def is_machine_live (host):

#  on passepar un fichier car la fonction python ping sur windows a un fonctionnement erratique

    os.system('ping ' + host +  ' > ' + file_name_log)

    with open(file_name_log, "r") as filin:
        resultat = filin.read()

    if (resultat.find("TTL") > 0):
        return 1
    elif (resultat.find("Impossible") > 0):
        return 0
    elif (resultat.find("trouver") > 0):
        return -1
    else:
        return -2
#
# --------------- transfert_file(username)
#
#   deploiement d'un fichier sur une machine
#                     username   username utilisé. Ce username doit avoir la clef publique de l'emeteur dans le fichier .ssh/authorized_keys
#                     host       nom du host (ou IP@ sur laquelle on transfert les fichiers
#                     ftp_commande_file_name nom du fichier de commande ftp
#                     fic_key adresse de la clef privée associée
#                     fichier_in local nom du fichier a transferer sans repertoire
#                     fichier_out  nom du fichier remote (doit avoir le droit d'ecriture pour username)
#                     dir_in repertoire local ou se trouve le fichier a envoyer
#
#
def transfert_file(username,host,ftp_commande_file_name,fic_key,fichier_in,fichier_out,dir_in,CN,type_fichier):

#    ecriture du fichier de commande ftp

    file_name = dir_in + "\\" +fichier_in

    if fichier_existe(file_name):

        fichier = open(ftp_commande_file_name, "w")
        # fichier.write("cd " + fichier_out)
        fichier.write("\nlcd " + dir_in)
        fichier.write("\nput " + fichier_in + " " + fichier_out)

        fichier.close()

        commande = "sftp -i" + fic_key + " " + username + "@" + host  + "< " + ftp_commande_file_name

        #print(commande)
        print("")
        print (bcolors.OK +  "====> Transfert du fichier " + type_fichier + " pour " + CN + " sur " + host)
        print("")
        os.system(commande)
        print(bcolors.RESET + " ")

    else:
        print("")
        print(bcolors.FAIL + "Erreur --------> Le fichier " + file_name + " n'existe pas")
        print("")

def fichier_existe(nom_complet):

    return os.path.exists(nom_complet)


# ---------------- main ---------------------
# ---------------- variable global---------------------

print(sys.argv)
#  deploiement_fichiers_outils.py fichier_xml_sans extension (all (defaut) machine telle que trouvée dans le fichier xml)

path = os.path.dirname(os.path.realpath(__file__))

#  on verifie si on est bien positionné dans le repertoire
c = "\deploiement_fichier_outil"
file_existe = False
verif = (path.find(c))
if len(sys.argv) >= 2 :
    file_name_liste = path[0:verif] + "\\deploiement_fichier_outil\\xml\\" + sys.argv[1] + ".xml"
    file_existe = fichier_existe(file_name_liste)

if len(sys.argv) >= 2 and file_existe:

    if verif > 0:

        file_name_log = path[0:verif] + "\\deploiement_fichier_outil\\log\\ping_log.log"
        ftp_commande_file_name = path[0:verif] + "\\deploiement_fichier_outil\\log\\ftp_command.txt"
        dir_in = path[0:verif] + "\\deploiement_fichier_outil\\fichier_a_deployer"

        with open(file_name_liste) as f:
            data_dict = json.load(f)
    
            for p in data_dict['items']:
                machine = p["id"]
                run_machine = check_run(machine,sys.argv)
                if run_machine:
                    machine_live = is_machine_live(machine)
                    if machine_live == 1:
                        print(" ")
                        print(" ")
                        print(" ============ > La machine " + machine + " repond ==> tentative de transfert")
                        for t in p["items"]:
                            transfert_file(p["username"],machine,ftp_commande_file_name,p["fic_key"],t["fichier_in"],t["fichier_out"],dir_in,t["CN"],t["type_fichier"])
                    elif machine_live == 0:
                        print(" ")
                        print(" ")
                        print(bcolors.FAIL + " ============ > La machine " + machine + " ne repond pas ==> on passe à la suivante")
                    elif machine_live == -1:
                        print(" ")
                        print(" ")
                        print(bcolors.FAIL + " ============ > Le nom : " + machine + " n'est pas resolvable ==> on passe à la suivante")
                    else:
                        print(" ")
                        print(" ")
                        print(bcolors.FAIL + " ============ > problème indeterminé sur " + machine + " ==> on passe à la suivante")
    else:
        print(" ")
        print(bcolors.FAIL + "Erreur --------> le repertoire de lancement " + path + " du programme devrait avoir un sous-repertoire : \deploiement_fichier_outil ce qui n'est pas le cas. Verifier votre repertoire de lancement")
        print(" ")
else:
    print(bcolors.FAIL + "Erreur --------> syntaxe : py deploiement_fichiers_outils.py (fichier_xml_sans extension) (all (defaut) ou machine telle que trouvée dans le fichier xml)")
    print(bcolors.FAIL + "Erreur --------> Soit la syntaxe est mauvaise soit le fichier descriptif xml n'existe pas")